OSDN Git Service

x86-mterp bug fix; support host mode in tests
[android-x86/dalvik.git] / tests / run-all-tests
1 #!/bin/bash
2 #
3 # Copyright (C) 2007 The Android Open Source Project
4 #
5 # Licensed under the Apache License, Version 2.0 (the "License");
6 # you may not use this file except in compliance with the License.
7 # You may obtain a copy of the License at
8 #
9 #     http://www.apache.org/licenses/LICENSE-2.0
10 #
11 # Unless required by applicable law or agreed to in writing, software
12 # distributed under the License is distributed on an "AS IS" BASIS,
13 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14 # See the License for the specific language governing permissions and
15 # limitations under the License.
16
17 # Set up prog to be the path of this script, including following symlinks,
18 # and set up progdir to be the fully-qualified pathname of its directory.
19 prog="$0"
20 while [ -h "${prog}" ]; do
21     newProg=`/bin/ls -ld "${prog}"`
22     newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
23     if expr "x${newProg}" : 'x/' >/dev/null; then
24         prog="${newProg}"
25     else
26         progdir=`dirname "${prog}"`
27         prog="${progdir}/${newProg}"
28     fi
29 done
30 oldwd=`pwd`
31 progdir=`dirname "${prog}"`
32 cd "${progdir}"
33 progdir=`pwd`
34 prog="${progdir}"/`basename "${prog}"`
35
36 run_args=""
37 usage="no"
38
39 while true; do
40     if [ "x$1" = "x--local" ]; then
41         run_args="${run_args} --local"
42         shift
43     elif [ "x$1" = "x--host" ]; then
44         run_args="${run_args} --host"
45         shift
46     elif [ "x$1" = "x--reference" ]; then
47         run_args="${run_args} --reference"
48         shift
49     elif [ "x$1" = "x--jit" ]; then
50         run_args="${run_args} --jit"
51         shift
52     elif [ "x$1" = "x--fast" ]; then
53         run_args="${run_args} --fast"
54         shift
55     elif [ "x$1" = "x--portable" ]; then
56         run_args="${run_args} --portable"
57         shift
58     elif [ "x$1" = "x--debug" ]; then
59         run_args="${run_args} --debug"
60         shift
61     elif [ "x$1" = "x--zygote" ]; then
62         run_args="${run_args} --zygote"
63         shift
64     elif [ "x$1" = "x--no-verify" ]; then
65         run_args="${run_args} --no-verify"
66         shift
67     elif [ "x$1" = "x--no-optimize" ]; then
68         run_args="${run_args} --no-optimize"
69         shift
70     elif [ "x$1" = "x--valgrind" ]; then
71         run_args="${run_args} --valgrind"
72         shift
73     elif [ "x$1" = "x--dev" ]; then
74         run_args="${run_args} --dev"
75         shift
76     elif [ "x$1" = "x--update" ]; then
77         run_args="${run_args} --update"
78         shift
79     elif [ "x$1" = "x--help" ]; then
80         usage="yes"
81         shift
82     elif expr "x$1" : "x--" >/dev/null 2>&1; then
83         echo "unknown option: $1" 1>&2
84         usage="yes"
85         break
86     else
87         break
88     fi
89 done
90
91 if [ "$usage" = "yes" ]; then
92     prog=`basename $prog`
93     (
94         echo "usage:"
95         echo "  $prog --help     Print this message."
96         echo "  $prog [options]  Run all tests with the given options."
97         echo "  Options are all passed to run-test; refer to that for " \
98             "further documentation:"
99         echo "    --debug --dev --fast --local --no-optimize --no-verify" \
100             "--portable"
101         echo "    --reference --update --valgrind --zygote --host"
102     ) 1>&2
103     exit 1
104 fi
105
106 passed=0
107 failed=0
108 failNames=""
109
110 for i in *; do
111     if [ -d "$i" -a -r "$i" -a -r "${i}/info.txt" ]; then
112         ./run-test ${run_args} "$i"
113         if [ "$?" = "0" ]; then
114             ((passed += 1))
115         else
116             ((failed += 1))
117             failNames="$failNames $i"
118         fi
119     fi
120 done
121
122 echo "passed: $passed test(s)"
123 echo "failed: $failed test(s)"
124
125 for i in $failNames; do
126     echo "failed: $i"
127 done